
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>我眼中的领域驱动设计(转) / 憋错料</title>

    <meta name="description" content="我眼中的领域驱动设计(转) 原文地址:http://www.cnblogs.com/richieyang/p/5373250.html 有幸参与了一些领域驱动的项目,读了一些文章,也见识了一些不伦不类的架构,感觉对领域 驱动有了更进一步的认识.所以今天跟大伙探讨一下领域驱动设计,同时也对一些想要实践领域驱动设计却又无处下手,或者一些正在实践却又说不上领域驱动设计 到底好在哪的朋友一些指引方向.当然对于”领域驱动设计”这个主题而言从来不乏争论,所以大家可以在畅所欲言. 为什么要使用领域驱动设计? 从Eric Evans的&l ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">我眼中的领域驱动设计(转)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>原文地址：http://www.cnblogs.com/richieyang/p/5373250.html</p>
<p>有幸参与了一些领域驱动的项目，读了一些文章，也见识了一些不伦不类的架构，感觉对领域 驱动有了更进一步的认识。所以今天跟大伙探讨一下领域驱动设计，同时也对一些想要实践领域驱动设计却又无处下手，或者一些正在实践却又说不上领域驱动设计 到底好在哪的朋友一些指引方向。当然对于&rdquo;领域驱动设计&rdquo;这个主题而言从来不乏争论，所以大家可以在畅所欲言。</p>
<p>为什么要使用领域驱动设计？</p>
<p>从Eric Evans的《<a href="https://www.amazon.cn/%E9%A2%86%E5%9F%9F%E9%A9%B1%E5%8A%A8%E8%AE%BE%E8%AE%A1-%E8%BD%AF%E4%BB%B6%E6%A0%B8%E5%BF%83%E5%A4%8D%E6%9D%82%E6%80%A7%E5%BA%94%E5%AF%B9%E4%B9%8B%E9%81%93-%E5%9F%83%E6%96%87%E6%96%AF/dp/B004BA21U2?ie=UTF8&amp;*Version*=1&amp;*entries*=0" rel="external nofollow noreferrer">领域驱动设计：软件核心复杂性应对之道</a>》一书的书名就可以看出这一方法论是为了解决软件核心复杂性的。也就是说软件业务越来越复杂了，领域驱动设计可以让事情变得简单。而实际情况是：<strong>领域驱动设计的门槛很高，没有很深厚的面向对象编码能力几乎不可能实践成功。</strong></p>
<p>这一说法是否自相矛盾呢？Martin Fowler在<a href="https://www.amazon.cn/%E4%BC%81%E4%B8%9A%E5%BA%94%E7%94%A8%E6%9E%B6%E6%9E%84%E6%A8%A1%E5%BC%8F-%E7%A6%8F%E5%8B%92/dp/B003LBSRDM/ref=sr_1_1?s=books&amp;ie=UTF8&amp;qid=1460217008&amp;sr=1-1&amp;keywords=martin+fowler" rel="external nofollow noreferrer">PoEAA</a>一书中给了一个有力的解释：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwMDIxNi8yMDE2MDQvNjAwMjE2LTIwMTYwNDEwMDE0NDM1MzkwLTE0MjY4MDY4NDIucG5n.jpg" /></p>
<p>我们把三层架构等除了领域驱动之外的架构方式都可以归纳为以数据为中心的架构方式，在图中是黑色的粗实线；</p>
<p>领域驱动设计在图中是绿色的粗实线。</p>
<ul>
<li>当软件在开发初期，以数据驱动的架构方式非常容易上手，但是随着业务的增长和项目的推进，软件开发和维护难度急剧升高。</li>
<li>领域驱动设计则在项目初期就处在一个比较难以上手的位置，但是随着业务的增长和项目的推进，软件开发和维护难度平滑上升。</li>
</ul>
<p>这幅图形象的解释了领域驱动设计和传统的软件开发模式两者在软件开发过程中解决复杂性之间的差异。</p>
<p>领域驱动设计的核心是什么？</p>
<p>顾名思义，领域驱动设计的核心是<strong>领域模型</strong>，这一方法论可以通俗的理解为先找到业务中的领域模型，以领域模型为中心驱动项目的开发。而领域模型的设计精髓<strong>在于面向对象分析，在于对事物的抽象能力，</strong>一个领域驱动架构师必然是一个面向对象分析的大师。</p>
<p>在面向对象编程中讲究封装，讲究设计低耦合，高内聚的类。而对于一个软件工程来讲，仅仅只靠类的设计是不够的，我们需要把紧密联系在一起的业务设计 为一个领域模型，让领域模型内部隐藏一些细节，这样一来领域模型和领域模型之间的关系就会变得简单。这一思想有效的降低了复杂的业务之间千丝万缕的耦合关 系。</p>
<p>下图为&ldquo;以数据为中心的架构模式&rdquo;，表和表之间关系错综复杂：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwMDIxNi8yMDE2MDQvNjAwMjE2LTIwMTYwNDEwMDE0NDQ5NDIyLTgyNDQzMDM0MS5wbmc=.jpg" /></p>
<p>下图是&ldquo;领域模型&rdquo;：领域和领域之间只存在大粒度的接口和交互：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwMDIxNi8yMDE2MDQvNjAwMjE2LTIwMTYwNDEwMDE0NTEwNjg3LTIwMDU0ODYxMDAucG5n.jpg" /></p>
<p>初期学习DDD的朋友一定不会错过Eric Evans写的《<a href="https://www.amazon.cn/%E9%A2%86%E5%9F%9F%E9%A9%B1%E5%8A%A8%E8%AE%BE%E8%AE%A1-%E8%BD%AF%E4%BB%B6%E6%A0%B8%E5%BF%83%E5%A4%8D%E6%9D%82%E6%80%A7%E5%BA%94%E5%AF%B9%E4%B9%8B%E9%81%93-%E5%9F%83%E6%96%87%E6%96%AF/dp/B004BA21U2?ie=UTF8&amp;*Version*=1&amp;*entries*=0" rel="external nofollow noreferrer">领域驱动设计：软件核心复杂性应对之道</a>》，这本书名气很大，也是很多人入门领域驱动设计的首选读物，这本书提到了领域驱动设计中的一些概念：Repository，Domain，ValueObject等。但是初学者有可能得出一个错误的结论：<strong>有人误认为项目架构中加入***Repository，***Domain，***ValueObject就变成了DDD架构。</strong>如果没有悟出其精髓就在项目中加入这些概念，那充其量也不过是个三层架构；反之对于一个面向对象分析的高手而言，不使用这些概念也可以实现领域驱动设计。</p>
<p>以Repository的设计为例，我经常看到一些文章中对IRepository定义为：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8
</td>
<td>
<p><code>public</code> <code>interface</code> <code>IRepository&lt;TAggregateRoot&gt;</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>TAggregateRoot Get(int id);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void Remove(TAggregateRoot aggregateRoot);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>void Update(TAggregateRoot aggregateRoot);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//What‘s this?</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>TAggregateRoot Where(Expression&lt;Func&lt;TAggregateRoot, bool&gt;&gt; filter);</code></p>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//&hellip;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>领域驱动设计是以领域模型为基本单位，这表明在IRepository&lt;TAggregate&gt;接口中，只有Get(int id)，Update(TAggregateRoot aggregate)，Remove(TAggregateRoot aggregate)这三个接口是有意义的。 Where(Expression&lt;Func&lt;TAggregateRoot,bool&gt;&gt; filter)这一定义暴露了你是在在进行单表操作，对于领域模型来讲没有查询一说。</p>
<p>而对于IUserRepository这样一个稍微具体的接口定义：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7
</td>
<td>
<p><code>public</code> <code>interface</code> <code>IUserRepository : IRepository&lt;User&gt;</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//What‘s this?</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>List&lt;Rule&gt; GetRules(int id);</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//....</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>一个IUserRepository仍然是一个Repository，他也只能以User聚合根为单位进行操作。方法 List&lt;Rule&gt; GetRules(int id)将此Repository打回了原形，这不再是一个Repository，这是一个DAL。</p>
<p>正确的实现方式：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14
</td>
<td>
<p><code>public</code> <code>class</code> <code>User:AggregateRoot</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>List&lt;Rule&gt; GetRules()</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code> <code>null;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>void ApproveRequest(Request request)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code> <code>rules = user.GetRules();</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//......</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//如果有权限就批准&nbsp; </code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>这段代码体现了User作为一个领域模型，他拥有自己的职责和能力。</p>
<p>如何开始实践领域驱动设计？</p>
<p>正如本文通篇所说，领域驱动设计讲究的是领域模型的分析和对事物的抽象，从来没有提起过数据如何存取这个话题，言下之意在领域驱动设计中，我们不关心过数据如何存取，怎么样写linq效率高，使用懒加载还是include，这些实现细节会将你带入传统的三层架构模式中。</p>
<p>在领域驱动设计中要先设计领域模型，接着写Domain逻辑，至于数据库，仅仅是用来存储数据的工具。使用database first那不叫领域驱动设计，很明显你先设计的表结构，所以应该叫数据库驱动设计更为准确。更不要引入数据库独有的技术，例如触发器，存储过程等。数据 库除了存储数据外，其余一切逻辑都是Domain逻辑。</p>
<p>我们不妨以大家都比较熟悉的医院门诊看病流程举个例子，看看如何开始实践领域驱动设计：</p>
<p>我们暂且认为一个门诊看病流程就是一个完整的领域模型，此时你要忘掉数据库，不要再想表结构如何设计，而是就这一领域模型进行抽象：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41
</td>
<td>
<p><code>public</code> <code>class</code> <code>OutPatientProcess:AggregateRoot</code></p>
<p><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>Registration _registration { get; </code><code>private</code> <code>set; }</code><code>//挂号单</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>List&lt;Examination&gt; _examinations;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>IReadOnlyList&lt;Examination&gt; Examinations =&gt; _examinations.AsReadOnly();</code><code>//化验单</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>Prescription Prescription { get; </code><code>private</code> <code>set; }</code><code>//处方</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>DateTime ConsultaionTime { get; </code><code>private</code> <code>set; }</code><code>//接诊时间</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>Doctor Doctor { get; </code><code>private</code> <code>set; }</code><code>//接诊医师</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//开始一个门诊治疗过程</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>void StartProcess(Registration registration)</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_registration = registration;</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>InquireSymptoms();</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>WriteOutExamination();</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>WritePrescription();</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//询问病人病情</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>void InquireSymptoms()</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//开立化验单</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>void WriteOutExamination()</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_examinations.Add(</code><code>new</code> <code>Examination());</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//填写处方</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>void WritePrescription()</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>我们暂且不讨论这一模型是否符合真实场景，但是这个例子带你迈入了领域驱动设计的第一步，同时这个例子也向你展示了软件开发是可以不用先设计数据库 的。当你写好所有的Domain逻辑后再考虑把这个类持久化在数据库中就好了。在我眼中，数据库仅仅是一个保存数据的东西，不要把他过早的耦合在代码中。 这一强调了很多遍的观点影响着你能否成功实践DDD。</p>
<p>CQRS架构展望</p>
<p>话虽这样说，但是既然你在使用关系数据库，有人就会免不了跟你提起性能怎么优化这样的话题。这也是传统ORM+关系数据库实现领域驱动设计的硬伤， 特别是当你的领域模型Scope设计过大，意味着Repository中的操作每次都要关联一堆表出来，特别是有人设计数据喜欢遵守第N范式这种基本就没 辙了（没有贬低遵守这些范式的意思，只是这样设计的数据库+ORM会产生较多关联，相对应的设计为表结构冗余设计，有利于ORM提升性能），不得不说到了 最后由于数据库的存储性能问题，我们又一次将数据库纳入到了考虑范围。</p>
<p>解决这一问题的方案是CQRS架构， Query端各种缓存和Nosql，顺便把搜索引擎也用上，让你的软件飞奔起来。这一架构解耦了数据库操作，你基本没有机会跟数据库打交道并且还解决了数据存储的性能问题。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwMDIxNi8yMDE2MDQvNjAwMjE2LTIwMTYwNDEwMjIxOTQ5Mzc1LTE2Mzk5NjU5MjIuanBn.jpg" /></p>
<p>这一进化过程也解开了一些人的疑虑，为什么从刚开始写代码就开始学习各种设计模式，但是从来没有机会使用过？因为你所写的代码无时无刻不耦合着数据库这一&ldquo;毒瘤&rdquo;，而数据库操作作为一种实现细节掺杂在你的代码中，所以领域驱动设计为此而生，你准备好了吗？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwMDIxNi8yMDE2MDQvNjAwMjE2LTIwMTYwNDEwMDE0NjAyMjgxLTEwMDc1OTE3ODQucG5n.jpg" /></p>
<p>分类: <a href="http://www.cnblogs.com/richieyang/category/564708.html" rel="external nofollow noreferrer">.NET</a></p>
<p>好文要顶 关注我 收藏该文 <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9pY29uX3dlaWJvXzI0LnBuZw==.jpg" /> <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy93ZWNoYXQucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljLmNuYmxvZ3MuY29tL2ZhY2UvNjAwMjE2LzIwMTQwMTE4MjMyODI0LnBuZw==.jpg" /></p>
<p><a href="http://home.cnblogs.com/u/richieyang/" rel="external nofollow noreferrer">richiezhang</a><br />
<a href="http://home.cnblogs.com/u/richieyang/followees" rel="external nofollow noreferrer">关注 - 20</a><br />
<a href="http://home.cnblogs.com/u/richieyang/followers" rel="external nofollow noreferrer">粉丝 - 399</a></p>
<p>荣誉：<a href="http://www.cnblogs.com/expert/" rel="external nofollow noreferrer">推荐博客</a></p>
<p><a>+加关注</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 18:23:37 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>我眼中的领域驱动设计(转)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49LP2n3.html" rel="bookmark">我眼中的领域驱动设计</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有幸参与了一些领域驱动的项目,读了一些文章,也见识了一些不伦不类的架构,感觉对领域驱动有了更进一步的认识.所以今天跟大伙探讨一下领域驱动设计,同时也对一些想要实践领域驱动设计却又无处下手,或者一些正在实践却又说不上领域驱动设计到底好在哪的朋友一些建议.当然对于领域驱动设计这个主题而言从来不乏争论,所以大家可以在畅所欲言. 为什么要使用领域驱动设计? 从Eric Evans写的&lt;领域驱动设计:软件核心复杂性应对之道&gt;一书的书名就可以看出这一方法论是为了解决软件核心复杂性的.也就是说软件业务越来越			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jrvwZ0.html" rel="bookmark">领域驱动设计之单元测试最佳实践&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				领域驱动设计之单元测试最佳实践(一) 介绍完了DDD案例,我们终于可以进入主题了,本方案的测试代码基于Xunit编写,断言组件采用了FluentAssertions,类似的组件还有Shouldly.另外本案例使用了Code Contracts for .NET,如果不安装此插件,可能有个别测试不能正确Pass. 为了实现目标中的第二点:&quot;尽量不Mock,包括数据库读取部分”,我尝试过3种方案: 1.测试代码连接真实数据库,只需要将测试数据库配置到测试项目中的web.config中,即可达到这一目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyWkRa3.html" rel="bookmark">领域驱动设计战略原则</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前发在别的地方了,据说标题不好,改个标题... 去年就打算总结一下,结果新换的工作特别忙,就迟迟没有认真动手.主要内容是很多初学DDD甚至于学习很长时间的同学没有弄明白DDD是什么,适合什么情况.这世界上没有银弹,抛开了适合的场景孤立的去研究DDD,在学习过程中还可以,但是应用到实际项目时就会遇到各种坑,到头来各种妥协,我看到很多同学遇到这种情况,最后怪DDD,说DDD不实用云云.另有一些都没细了解过就抨击反对的,事实上,要想否定个东西,你总要了解了才有发言权. 一.误区 综合起来主要有一下几			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/bMoxqb0.html" rel="bookmark">领域驱动设计-入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				领域驱动设计围绕着对象进行设计,类似于传统的OO,但是还是不同的. 传统的OO更像是贫血的领域对象,它具有数据,很多get set方法,但是缺少业务逻辑.客户端使用时,需要进行一大串的set操作.举个栗子: 这种方式中customer是一个贫血的领域对象,客户端必须进行很多的set,最后调用dao进行保存. --------------- 那么,怎样才是不贫血的领域对象呢?主要看两点:boundedcontext,通用领域语言. 领域对象是通过通用领域语言进行描述的,通用语言是领域专家和开发人员			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4Jjnl4.html" rel="bookmark">我的&OpenCurlyDoubleQuote;第一次&rdquo;，就这样没了：DDD（领域驱动设计）理论结合实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				写在前面 插一句:本人超爱落网-&lt;平凡的世界&gt;这一期,分享给大家. 阅读目录: 关于DDD 前期分析 框架搭建 代码实现 开源-发布 后记 第一次听你,清风吹送,田野短笛:第一次看你,半弯新湖,鱼跃翠堤:第一次念你,燕飞巢冷,释怀记忆:第一次梦你,云翔海岛,轮渡迤逦:第一次认你,怨江别续,草桥知己:第一次怕你,命悬一线,遗憾禁忌:第一次悟你,千年菩提,生死一起. 人生有很多的第一次:小时候第一次牙牙学语.第一次学蹒跚学步...长大后第一次上课.第一次逃课.第一次骑自行车.第一次懂事.第一次和喜			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMzmNW4.html" rel="bookmark">DDD领域驱动设计基本理论知识总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				领域驱动设计之领域模型 加一个导航,关于如何设计聚合的详细思考,见这篇文章. 2004年Eric Evans 发表Domain-Driven Design –Tackling Complexity in the Heart of Software (领域驱动设计),简称Evans DDD.领域驱动设计分为两个阶段: 以一种领域专家.设计人员.开发人员都能理解的通用语言作为相互交流的工具,在交流的过程中发现领域概念,然后将这些概念设计成一个领域模型:由领域模型驱动软件设计,用代码来实现该领域模型:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMPr263.html" rel="bookmark">&lpar;转载）浅谈我对DDD领域驱动设计的理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:http://www.cnblogs.com/netfocus/p/5548025.html 从遇到问题开始 当人们要做一个软件系统时,一般总是因为遇到了什么问题,然后希望通过一个软件系统来解决. 比如,我是一家企业,然后我觉得我现在线下销售自己的产品还不够,我希望能够在线上也能销售自己的产品.所以,自然而然就想到要做一个普通电商系统,用于实现在线销售自己企业产品的目的. 再比如,我是一家互联网公司,公司有很多系统对外提供服务,面向很多客户端设备.但是最近由于各种原因,导致服务经常出故			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMgpDN0.html" rel="bookmark">WCF客户端配置以及代理-----基于DDD领域驱动设计的WCF&plus;EF&plus;WPF分层框架（4）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				写在最前面:转载请注明出处 目录置顶: 关于项目--------------------基于DDD领域驱动设计的WCF+EF+WPF分层框架(1) 架构搭建--------------------基于DDD领域驱动设计的WCF+EF+WPF分层框架(2) WCF服务端具体实现---------基于DDD领域驱动设计的WCF+EF+WPF分层框架(3) WCF客户端配置以及代理-----基于DDD领域驱动设计的WCF+EF+WPF分层框架(4) Domain具体实现------------基于DD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pvzEJ0.html" rel="bookmark">什么是领域驱动设计&lpar;Domain Driven Design&rpar;&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文是从 What is Domain Driven Design? 这篇文章翻译而来. ”…在很多领域,专家的作用体现在他们的专业知识上而不是智力上.“ -- Don Reinertsen 领域驱动设计(Domain Driven Design)是一种软件开发方法,目的是让软件系统在实现时准确的基于对真实业务过程的建模并根据真实业务过程的调整而调整. 传统的开发工作趋向于一种以技术为先导的过程,需求从业务方传递到开发团队,开发人员依据需求上的描述创造出最有可能的假想. 在瀑布开发过程中,这导致			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGYAQM.html" rel="bookmark" class="title">linux命令行模式下对FTP服务器进行文件上传下载</a>
					<div>
						参考源:点击这里查看 1. 连接ftp服务器 格式:ftp [hostname| ip-address]a)在linux命令行下输入: ftp 192.168.1.1 b)服务器询问你用户名和密码,分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n16mPM.html" rel="bookmark" class="title">swift使用ASIHttpRequest</a>
					<div>
						添加第三方库ASIHttpRequest 添加SystemConfiguration.framework, MobileCoreServices.framework,CoreGraphics.fram ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNGZP3.html" rel="bookmark" class="title">使用NTP进行CentOS7时间同步</a>
					<div>
						NTP时钟同步方式说明 NTP在linux下有两种时钟同步方式,分别为直接同步和平滑同步: 直接同步 使用ntpdate命令进行同步,直接进行时间变更.如果服务器上存在一个12点运行的任务,当前服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2Dvl3.html" rel="bookmark" class="title">格式化字符串攻击原理及示例&period;RP</a>
					<div>
						格式化字符串攻击原理及示例 一.类printf函数簇实现原理 类printf函数的最大的特点就是,在函数定义的时候无法知道函数实参的数目和类型. 对于这种情况,可以使用省略号指定参数表. 带有省略号的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlqNp4.html" rel="bookmark" class="title">【翻译自mos文章】oracle支持在RDBMS HOME 下的 符号链接（ Symbolic Links）吗？</a>
					<div>
						oracle支持在RDBMS HOME 下的 符号链接( Symbolic Links)吗? 參考原文: Does Oracle support Symbolic Links in the RDBMS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vv9b93.html" rel="bookmark" class="title">看看我们以前搞过的几个对象</a>
					<div>
						1:让我们来认识一下java中的vo VO :值对象 (Value Object) VO 是用 new 关键字创建,由 GC 回收的. VO 是值对象,精确点讲它是业务对象,是存活在业务层的,是业务逻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02m792M.html" rel="bookmark" class="title">课后作业 05 -- 输出一段带字母与数字的随机数</a>
					<div>
						Console.Write(&quot;您欲得到四位随机验证码的数量是:&quot;); int a = int.Parse(Console.ReadLine()); Console.WriteLin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j7n1W3.html" rel="bookmark" class="title">朝花夕拾-android 一个注册新用户时，多步填写用户资料的框架</a>
					<div>
						源码地址:http://git.oschina.net/zj2012zy/Android-Demo/tree/master/AndroidDemo/setpregister 效果如下: 基本思路: 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2QQjM.html" rel="bookmark" class="title">CreateThread传递多个参数的方法（利用结构体的参数指针）</a>
					<div>
						很多朋友一直都在问CreateThread如何传递多个参数,CreateThread传递参数的方式是指针传递的,所以这里也可以利用指针来做!Demo 关键代码如下: type  TfrmTestThr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKmBj4.html" rel="bookmark" class="title">前端开发涉及到的编码问题</a>
					<div>
						前言 URL只能使用英文字母.阿拉伯数字和某些标点符号,不能使用其他文字和符号.比如,世界上有英文字母的网址&quot;http://www.abc.com&quot;,但是没有希腊字母的网址&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YXqyqM.html" rel="bookmark" class="title">初次接触Servlet3&period;0</a>
					<div>
						Servlet3.0 一.要求 MyEclipes10.0或以上版本! 发布到Tomcat7.0或以上版本!二.步骤 创建JavaEE6.0应用 --------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38L5AK3.html" rel="bookmark" class="title">笔试题30&period; LeetCode OJ &lpar;17&rpar;</a>
					<div>
						这个题目有意思,和生活接近,题目的意思一看就知道,应该是字符串的全排列吧.但是需要注意的是有几数字字符是没有对应的字符串的,比如'0'和'1',所以我们的输入字符串中若有他们,则将它们过滤掉.这个题我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8Pa14.html" rel="bookmark" class="title">Android自己定义控件（状态提示图表）</a>
					<div>
						[工匠若水 http://blog.csdn.net/yanbober 转载烦请注明出处.尊重分享成果] 1 背景 前面分析那么多系统源代码了.也该暂停下来歇息一下,趁昨晚闲着看见一个有意思的需求就操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5QR50.html" rel="bookmark" class="title">列举C&plus;&plus;数据库开源工具</a>
					<div>
						更简洁的C++数据库访问框架-soci SOCI及litesql对比 easySQLite使用帮助 SOCI.LiteSQL.POCO数据库访问类库对比 (1)SOCI相关资料较少,需要编译方可使用. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGVap0.html" rel="bookmark" class="title">JQuery的AJAX调用（一）&mdash;&mdash;加载传递数据</a>
					<div>
						一,load方法异步请求数据 使用load()方法通过Ajax请求加载服务器中的数据,并把返回的数据放置到指定的元素中,它的调用格式为: load(url,[data],[callback]) 参数u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38omal0.html" rel="bookmark" class="title">广州女生手机被偷 里面的身份证出卖了支付宝密码丨丢手机后必做6件事&lpar;转&rpar;</a>
					<div>
						转自:这里 现在的智能手机不仅能刷微信,还能刷卡支付.派红包,殊不知,它给我们带来方便的同时,也暗藏了诸多风险. 广州女生小陈近日就因为手机丢失导致支付宝被人盗刷上万元! 支付宝有支付密码,怎么还会被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlAmGM.html" rel="bookmark" class="title">STM32F4 输入输出&lpar;GPIO&rpar;模式理解</a>
					<div>
						stm32的GPIO的配置模式有好几种,包括: 1. 模拟输入: 2. 浮空输入: 3. 上拉输入: 4. 下拉输入: 5. 开漏输出: 6. 推挽输出: 7. 复用开漏输出: 8. 复用推挽输出 如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y1OJv0.html" rel="bookmark" class="title">N个数GCD求解法</a>
					<div>
						[N个数GCD求解法] 1.质因数分解法. 2.两两求解法. 3.更相减损法. 例题 4.Trick1. 5.Trick2. 6.Trick3.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9Aqp0.html" rel="bookmark" class="title">pyqt最小化学习</a>
					<div>
						# -*- coding: cp936 -*- #!/usr/bin/env python # -*- coding:utf-8 -*- from PyQt4 import QtCore, QtGui ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49voG1M.html" rel="bookmark" class="title">源码编译Hadoop-2&period;2版本</a>
					<div>
						刚接触hadoop的时候,都会遇到一个头大的问题,如下: WARN org.apache.hadoop.util.NativeCodeLoader: Unable to load native-had ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
